from wow_token.db.cached_range import CachedRange
from wow_token.db.year_month import YearMonth
from wow_token.flavor import Flavor
from wow_token.region import Region


class Trinity:
    def __init__(self, _region: Region, _flavor: Flavor, _range: CachedRange | YearMonth):
        self._region = _region
        self._flavor = _flavor
        self._range = _range

    @property
    def region(self) -> Region:
        return self._region

    @property
    def flavor(self) -> Flavor:
        return self._flavor

    @property
    def range(self) -> CachedRange | YearMonth:
        return self._range

    def __str__(self):
        return f"{self._region.value}-{self._flavor.value}-{self._range}"
